'use strict';

var _babblerScriptJs = require('babbler-script-js');

var _babblerScriptJs2 = _interopRequireDefault(_babblerScriptJs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// BabblerScriptProgramCounter.js

var React = require('react');

//import BabblerScript from '../../babbler-script-js/src/babbler-script';


// Счетчик программы pc (program counter) BabblerScript
var BabblerScriptProgramCounter = React.createClass({
    displayName: 'BabblerScriptProgramCounter',


    getInitialState: function getInitialState() {
        return {
            pc: this.props.babblerScript.programCounter
        };
    },

    componentDidMount: function componentDidMount() {
        this.programCounterListener = function (pc) {
            this.setState({ pc: pc });
        }.bind(this);

        this.props.babblerScript.on(_babblerScriptJs2.default.Event.PROGRAM_COUNTER, this.programCounterListener);
    },

    componentWillUnmount: function componentWillUnmount() {
        // почистим слушателей
        this.props.babblerScript.removeListener(_babblerScriptJs2.default.Event.PROGRAM_COUNTER, this.programCounterListener);
    },

    render: function render() {

        return React.createElement(
            'span',
            { style: this.props.style },
            'pc=',
            this.state.pc
        );
    }
});

// отправляем компонент на публику
module.exports = BabblerScriptProgramCounter;